package cn.ibizlab.core.rule.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.rule.domain.RuleItem;
import cn.ibizlab.core.rule.filter.RuleItemSearchContext;
import cn.ibizlab.core.rule.service.IRuleItemService;

import cn.ibizlab.util.helper.CachedBeanCopier;
import cn.ibizlab.util.helper.DEFieldCacheMap;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.core.rule.mapper.RuleItemMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[规则] 服务对象接口实现
 */
@Slf4j
@Service("RuleItemServiceImpl")
public class RuleItemServiceImpl extends ServiceImpl<RuleItemMapper, RuleItem> implements IRuleItemService {

    @Autowired
    @Lazy
    protected cn.ibizlab.core.rule.service.IExecResultService execresultService;
    @Autowired
    @Lazy
    protected cn.ibizlab.core.lite.service.IMetaModelService metamodelService;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(RuleItem et) {
        fillParentData(et);
        if(!this.retBool(this.baseMapper.insert(et))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getRuleId()), et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<RuleItem> list) {
        list.forEach(item->fillParentData(item));
        this.saveBatch(list, batchSize);
    }

    @Override
    @Transactional
    public boolean update(RuleItem et) {
        fillParentData(et);
        if(!update(et, (Wrapper) et.getUpdateWrapper(true).eq("ruleid", et.getRuleId()))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getRuleId()), et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<RuleItem> list) {
        list.forEach(item->fillParentData(item));
        updateBatchById(list, batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result = removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public RuleItem get(String key) {
        RuleItem et = getById(key);
        if(et == null){
            et = new RuleItem();
            et.setRuleId(key);
        }
        else {
        }
        return et;
    }

    @Override
    public RuleItem getDraft(RuleItem et) {
        fillParentData(et);
        return et;
    }

    @Override
    @Transactional
    public RuleItem buildRuleFile(RuleItem et) {
        //自定义代码
        return et;
    }

    @Override
    @Transactional
    public boolean buildRuleFileBatch(List<RuleItem> etList) {
        for(RuleItem et : etList) {
            buildRuleFile(et);
        }
        return true;
    }

    @Override
    public boolean checkKey(RuleItem et) {
        return (!ObjectUtils.isEmpty(et.getRuleId())) && (!Objects.isNull(this.getById(et.getRuleId())));
    }
    @Override
    @Transactional
    public RuleItem modelchange(RuleItem et) {
        //自定义代码
        return et;
    }

    @Override
    @Transactional
    public boolean modelchangeBatch(List<RuleItem> etList) {
        for(RuleItem et : etList) {
            modelchange(et);
        }
        return true;
    }

    @Override
    @Transactional
    public boolean save(RuleItem et) {
        if(!saveOrUpdate(et)) {
            return false;
        }
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(RuleItem et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? getProxyService().update(et) : getProxyService().create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<RuleItem> list) {
        list.forEach(item->fillParentData(item));
        List<RuleItem> create = new ArrayList<>();
        List<RuleItem> update = new ArrayList<>();
        for (RuleItem et : list) {
            if (ObjectUtils.isEmpty(et.getRuleId()) || ObjectUtils.isEmpty(getById(et.getRuleId()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<RuleItem> list) {
        list.forEach(item->fillParentData(item));
        List<RuleItem> create = new ArrayList<>();
        List<RuleItem> update = new ArrayList<>();
        for (RuleItem et : list) {
            if (ObjectUtils.isEmpty(et.getRuleId()) || ObjectUtils.isEmpty(getById(et.getRuleId()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
    }


	@Override
    public List<RuleItem> selectByModelId(String id) {
        return baseMapper.selectByModelId(id);
    }
    @Override
    public void removeByModelId(String id) {
        this.remove(new QueryWrapper<RuleItem>().eq("modelid",id));
    }

    public IRuleItemService getProxyService() {
        return cn.ibizlab.util.security.SpringContextHolder.getBean(this.getClass());
    }
	@Override
    public void saveByModelId(String id,List<RuleItem> list) {
        if(list==null)
            return;
        Set<String> delIds=new HashSet<String>();
        List<RuleItem> _update=new ArrayList<RuleItem>();
        List<RuleItem> _create=new ArrayList<RuleItem>();
        for(RuleItem before:selectByModelId(id)){
            delIds.add(before.getRuleId());
        }
        for(RuleItem sub:list) {
            sub.setModelId(id);
            if(ObjectUtils.isEmpty(sub.getRuleId()))
                sub.setRuleId((String)sub.getDefaultKey(true));
            if(delIds.contains(sub.getRuleId())) {
                delIds.remove(sub.getRuleId());
                _update.add(sub);
            }
            else
                _create.add(sub);
        }
        if(_update.size()>0)
            getProxyService().updateBatch(_update);
        if(_create.size()>0)
            getProxyService().createBatch(_create);
        if(delIds.size()>0)
            getProxyService().removeBatch(delIds);
	}


    /**
     * 查询集合 数据集
     */
    @Override
    public Page<RuleItem> searchDefault(RuleItemSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<RuleItem> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<RuleItem>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }



    /**
     * 为当前实体填充父数据（外键值文本、外键值附加数据）
     * @param et
     */
    private void fillParentData(RuleItem et){
        //实体关系[DER1N_RU_ITEM_META_MODEL_MODELID]
        if(!ObjectUtils.isEmpty(et.getModelId())){
            cn.ibizlab.core.lite.domain.MetaModel model=et.getModel();
            if(ObjectUtils.isEmpty(model)){
                cn.ibizlab.core.lite.domain.MetaModel majorEntity=metamodelService.get(et.getModelId());
                et.setModel(majorEntity);
                model=majorEntity;
            }
            et.setModelName(model.getName());
            et.setSystemId(model.getSystemId());
        }
    }




    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }






}



